<?php

/**
 * @file
 * Admin menu callbacks.
 */

/**
 * Override settings form.
 */
function multivariate_override_settings_form() {
  $form = array();
  $form['multivariate'] = array('#tree' => TRUE);
  $res = db_query('SELECT nid, title FROM node n WHERE type = "multivariate"');
  while($node = db_fetch_object($res)) {
    $test_node = multivariate_load_test_study($node->nid);
    $test_node->title = $node->title;
    $test_results = multivariate_get_results($test_node);
 
    $options = array('disable' => t('Disable override'));
    foreach ($test_results as $mutation_id => $test_result) {
      $options[$mutation_id] = $test_result['label'];
    }
    
    $form['multivariate'][$test_node->nid] = array(
      '#type' => 'radios',
      '#title' => check_plain($test_node->title),
      '#default_value' => isset($_COOKIE['multivariate_' . $test_node->nid . '_override']) ? $_COOKIE['multivariate_' . $test_node->nid . '_override'] : 'disable',
      '#options' => $options,
    );
  }
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save')
  );

  return $form;
}

/**
 * Submit handler.
 */
function multivariate_override_settings_form_submit($form, &$form_state) {
  global $cookie_domain;
  
  foreach ($form_state['values']['multivariate'] as $test_nid => $mutation_id) {
    if ($mutation_id == 'disable') {
      setcookie('multivariate_' . $test_nid . '_override', '', time() - 90000, '/', $cookie_domain);
    }
    else {
      setcookie('multivariate_' . $test_nid . '_override', $mutation_id, MULTIVARIATE_COOKIE_DURATION, '/', $cookie_domain);
    }
  }
}
