
/**
 * Attaches the multivariate study node form behavior.
 */
Drupal.behaviors.multivariateStudyForm = function(context) {
  $('.variants-number-control-show:not(.processed)').each(function (i, v) {
    var $varShowControl = $(v).addClass('processed');
    var $varNumControl = $varShowControl.siblings('.variants-number-control');
    $varShowControl.show();
    $varNumControl.hide();
    $varShowControl.find('a.variant-change').click(function () {
      $varShowControl.hide();
      $varNumControl.show();
      return false;
    });
  });
}

/**
 * Charting of multivariate study results.
 */
if (typeof google !== 'undefined') {
  google.load('visualization', '1', {packages:['corechart']});
  google.setOnLoadCallback(drawChart);
}

function drawChart() {
  var data = new google.visualization.DataTable();
  for(key in Drupal.settings.multivariate.chartData.columns) {
    data.addColumn(Drupal.settings.multivariate.chartData.columns[key], key);
  }
  data.addRows(Drupal.settings.multivariate.chartData.rows);
  var chart = new google.visualization.BarChart(document.getElementById('multivariate-chart'));
  chart.draw(data, Drupal.settings.multivariate.chartData.options);
}
