<?php

/**
 * @file
 * Menu callbacks.
 */

/**
 * AHAH callback.
 */
function multivariate_change_variations_form_ahah() {
  list($form, $form_state) = multivariate_ahah_helper();

  $set_id = $form_state['clicked_button']['#set_id'];
  $form_variations =& $form['sets_fieldset']['sets'][$set_id]['variants'];
  unset($form_variations['#prefix'], $form_variations['#suffix']);
  
  drupal_json(array(
    'status' => TRUE,
    'data' => theme('status_messages') . drupal_render($form_variations)
  ));
}

/**
 * AHAH callback.
 */
function multivariate_change_sets_form_ahah() {
  list($form, $form_state) = multivariate_ahah_helper();

  $form_sets =& $form['sets_fieldset'];
  unset($form_sets['#prefix'], $form_sets['#suffix']);
  
  drupal_json(array(
    'status' => TRUE,
    'data' => theme('status_messages') . drupal_render($form_sets)
  ));
}

/**
 * AHAH callback.
 */
function multivariate_change_success_conditions_form_ahah() {
  list($form, $form_state) = multivariate_ahah_helper();

  unset($form['success_conditions_fieldset']['#prefix'], $form['success_conditions_fieldset']['#suffix']);  
  drupal_json(array(
    'status' => TRUE,
    'data' => theme('status_messages') . drupal_render($form['success_conditions_fieldset'])
  ));
}

/**
 * Export multivariate data.
 *
 * @param object $node
 *   Multivariate node object.
 */
function multivariate_node_export($node) {
  header('Content-Disposition: attachment; filename="multivariate-' . $node->test_nid . '.csv"');
  header('Content-Type: text/plain');

  $results = db_query('SELECT mutation_id, count, success
    FROM {multivariate_mutations}
    WHERE test_nid = %d', $node->test_nid);

  echo '"' . implode('","', array('mutation', 'count', 'success')) . '"' . "\n";
  while ($result = db_fetch_array($results)) {
    $binary = multivariate_mutation_correct(decbin($result['mutation_id']), $node);
    echo '"' . implode('","', array($binary, $result['count'], $result['success'])) . '"' . "\n";
  }
}

/* Helpers */

/**
 * Helper for form ahah handling.
 * @return array
 *   Array with $form and $form_state.
 */
function multivariate_ahah_helper() {
  include_once 'modules/node/node.pages.inc';

  $form_state = array('storage' => NULL, 'submitted' => FALSE);
  $form_build_id = $_POST['form_build_id'];
  $form = form_get_cache($form_build_id, $form_state);

  $args = $form['#parameters'];
  $form_id = array_shift($args);
  $form_state['post'] = $form['#post'] = $_POST;
  $form['#programmed'] = $form['#redirect'] = FALSE;

  drupal_process_form($form_id, $form, $form_state);
  $form = drupal_rebuild_form($form_id, $form_state, $args, $form_build_id);

  // Removes status messages for required fields.
  //drupal_get_messages();
  
  return array($form, $form_state);
}
